`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/03/08 00:33:50
// Design Name: 
// Module Name: freqdiv_50M
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define HALF_TARGET_FREQ 26'd50000000
module freqdiv_50M(
    clk_out, //divided clock output
    clk,    //clock input
    rst_n   //low-active reset
);
    output reg clk_out; //divided clk output(in always block)
    input clk, rst_n; //clock input, low-active reset
    
    reg clk_tmp; //input to the D-FF (for toggling)
    
    reg [25:0] cnt; //remainder of the counter
    reg [25:0] cnt_tmp_a; //input to selector
    reg [25:0] cnt_tmp_b; //input to D-FF
   
    always @*
        begin
          cnt_tmp_a = cnt + 1'b1; //combinational logics to increment(neglecting overflow)
          
          if (cnt_tmp_a == `HALF_TARGET_FREQ) //combinational logics to select
            begin
            cnt_tmp_b = 26'd0;  //restart the counter
            clk_tmp = ~clk_out; // toggle the clock signal
            end
        else
            begin
            cnt_tmp_b = cnt_tmp_a; //keep counting
            clk_tmp = clk_out;    
            end
        end
    
    
    //sequential logics
    always @(posedge clk or negedge rst_n)
    if (~rst_n)
        begin
        cnt <= 26'd0;
        clk_out <= 1'b0;
        end
    else
        begin
        cnt <= cnt_tmp_b;   //let the signal pass one D-FF
        clk_out <= clk_tmp; //let the signal pass another D-FF
        end
        
endmodule
